﻿Global Dim lockedColor(#maxLockedSort)

Global pic
Global floorInvSPR
Global Dim slotSPR(#invTypeMax)
Global Dim selectedSlotSPR(#invTypeMax,1)
Global Dim closeInvSPR(1)
Global Dim invTabSPR(1)
Global Dim invBorderSPR(3)
Global Dim floorSlotIMG(7)
Global sleepingSlotSPR
Global statBarSPR
Global pathNodeSPR
Global projectileSPR
Global shadeSPR
Global shineSPR
Global cursorSPR
Global mouseSPR
Global interactionRectangleSPR
Global mapSPR
Global mapOverlaySPR
Global Dim baseSPR(5)
Global Dim mappedSPR(15)
Global asciiPlayerSPR
Global Dim asciiIMG(#asciiMax)
Global defaultPainSPR
Global Dim externalSPR(extSpriteCounter)
Global Dim actorSPR(#actorTypeMax,#actorSubtypeMax,#actorClassMax,#actorSortMax,#actorQualityMax,#actorStatusMax,#animationFrameMax)



Procedure updateViewport()
	Define x, y

	ClearList(viewPort())
	For x = *player\x-lineOfSight To *player\x+lineOfSight
		For y = *player\y-lineOfSight To *player\y+lineOfSight
			_Dist(x,y,*player\x,*player\y)
			If distance <= (radiance)
				AddElement(viewPort())
				viewPort()\x = x-*player\x
				viewPort()\y = y-*player\y
			EndIf
		Next
	Next
EndProcedure


Procedure updateNegativeView()
	Define x, y
	Define dir
	Define legit
	Define primeDistance.f
	Dim coverTemp(xMax,yMax)
	
	ClearList(coverTile())
	ForEach	viewPort()
		x = limit(*player\x+viewPort()\x,1,xMax-1)
		y = limit(*player\y+viewPort()\y,1,yMax-1)
		_Dist(x,y,*player\x,*player\y)
		primeDistance = distance
		If bresenMap(x,y) And primeDistance <= radiance And withinScreen(x,y)
			For dir = 1 To 8
				If coverTemp(x+xMod(dir),y+yMod(dir))
					Continue
				EndIf
				legit = #False					
				If Not bresenMap(x+xMod(dir),y+yMod(dir)) Or Not withinScreen(x+xMod(dir),y+yMod(dir))
					legit = #True
				Else
					_Dist((x+xMod(dir)),(y+yMod(dir)),*player\x,*player\y)
					If distance > radiance
						legit = #True
					EndIf
				EndIf
				If legit
					AddElement(coverTile())
					coverTile()\x = x+xMod(dir)
					coverTile()\y = y+yMod(dir)
					coverTemp(coverTile()\x,coverTile()\y) = #True
				EndIf
			Next
		EndIf
	Next
EndProcedure



Procedure updateShine(xCenter,yCenter)
	Define dir, d
	Define x,y
	Dim bresenSave(0,0)
	CopyArray(bresenRef(),bresenSave())
	bresenRef(xCenter,yCenter) = 0
	
	
	For dir = 0 To 8
		x = xCenter+xMod(dir)
		y = yCenter+yMod(dir)
		If getBresenham(xCenter,yCenter,x,y,0)
			shineMap(x,y) +100
		EndIf
	Next
	For dir = 1 To 4
		For d = 0 To 2
			x = xCenter+(xMod(dir)*2)+xSide(dir,d)
			y = yCenter+(yMod(dir)*2)+ySide(dir,d)
			If getBresenham(xCenter,yCenter,x,y,0)
				shineMap(x,y) +10
			EndIf
		Next
	Next
	For dir = 1 To 4
		For d = 0 To 2
			x = xCenter+(xMod(dir)*3)+xSide(dir,d)
			y = yCenter+(yMod(dir)*3)+ySide(dir,d)
			If x >= 0 And x <= xMax And y > 0 And y <= yMax
				If getBresenham(xCenter,yCenter,x,y,0)
					shineMap(x,y) +1
				EndIf
			EndIf
		Next
	Next
	For dir = 5 To 8
		x = xCenter+(xMod(dir)*2)
		y = yCenter+(yMod(dir)*2)
		If getBresenham(xCenter,yCenter,x,y,0)
			shineMap(x,y) +1
		EndIf
	Next
	shineMap(xCenter,yCenter) + 1000
	
	
	CopyArray(bresenSave(),bresenRef())
EndProcedure




Procedure buildBaseMap()
	Define x, y
	
	Dim baseMap(xMax,yMax)
	For x = 0 To #xMax
		If Mod(x,3) = 0	:	progressBar(0,1) : EndIf
		If x > xMax
			Continue
		EndIf
		For y = 0 To #yMax
			If y > yMax	:	Continue	:	EndIf
			editBaseMap(x,y)
		Next
	Next
EndProcedure


Procedure editBaseMap(x,y)
	Define eachCount
	Define createWallDimension
	Define deleteWallDimension
	Define shadowDim
	
	If x > 0 And y > 0 And x < xMax And y < yMax
		baseMap(x,y) = 0		
		If floorMap(x,y) = 0 Or floorMap(x,y) = #doorIndex
			baseMap(x,y) = 2
			If floorMap(x,y+1) > #doorIndex	:	baseMap(x,y) = 1	:	EndIf
			If floorMap(x,y+1) > #doorIndex
				If floorMap(x-1,y) > #doorIndex And floorMap(x+1,y) > #doorIndex
					baseMap(x,y) = 5
				Else
					If floorMap(x-1,y) > #doorIndex	:	baseMap(x,y) = 3	:	EndIf
					If floorMap(x+1,y) > #doorIndex	:	baseMap(x,y) = 4	:	EndIf
				EndIf
			EndIf
		Else
			If floorMap(x,y+1) <= #doorIndex	:	createWallDimension = #True	:	EndIf
			If floorMap(x,y+1) > #doorIndex		:	deleteWallDimension = #True	:	EndIf
		EndIf
	
	Else
		baseMap(x,y) = 2
	EndIf
	
	If createWallDimension Or deleteWallDimension
		_EachActor(#hasImageP,0)
			If actor()\x = x And actor()\y = y And actor()\type = #patternActor And actor()\subtype = #wallDimension
				createWallDimension = #False
				If deleteWallDimension
					markForKill(@actor())
				Else
					checkWallCorners(x,y,@actor()) ;existierende Wall-Dimension (Form anpassen)
				EndIf
				Break
			EndIf
		_EndEach()
	EndIf
	If createWallDimension
		actorFactory(#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#True,#False,
		             0,#patternActor,#wallDimension,0,0,0,0,#dimensionDepth,#defaultVisibility,#False,#False,#False,#nullInteract,x,y,-1)
		actor()\alpha = 175
		checkWallCorners(x,y,@actor())
	EndIf
	
	
	
	
	If x > 0 And x < xMax And y > 0 And y < yMax
		If floorMap(x,y) = 0 And floorMap(x+1,y) > #doorIndex And floorMap(x,y+1) > #doorIndex	:	shadowDim = 1	:	EndIf
		If floorMap(x,y) > #doorIndex
			If floorMap(x-1,y) <= #doorIndex
				shadowDim = 2
				If floorMap(x-1,y+1) > #doorIndex	:	shadowDim = 3	:	EndIf
				If floorMap(x,y-1) <= #doorIndex And floorMap(x+1,y-1) > #doorIndex And floorMap(x-1,y+1) > #doorIndex	:	shadowDim = 4	:	EndIf
				If floorMap(x-1,y-1) > #doorIndex
					shadowDim = 5
					If floorMap(x-1,y+1) > #doorIndex	:	shadowDim = 6	:	EndIf
				EndIf
			EndIf
			If floorMap(x,y-1) <= #doorIndex
				If floorMap(x-1,y-1) <= #doorIndex And floorMap(x+1,y-1) <= #doorIndex And floorMap(x-1,y) > #doorIndex		:	shadowDim = 7	:	EndIf
				If floorMap(x-1,y-1) <= #doorIndex And floorMap(x+1,y-1) > #doorIndex And floorMap(x-1,y) > #doorIndex		:	shadowDim = 8	:	EndIf
				If floorMap(x-1,y) <= #doorIndex ;Corner Shadows
					If floorMap(x-1,y+1) <= #doorIndex And floorMap(x+1,y-1) <= #doorIndex	:	shadowDim = 9	:	EndIf
					If floorMap(x-1,y+1) <= #doorIndex And floorMap(x+1,y-1) > #doorIndex	:	shadowDim = 10	:	EndIf
					If floorMap(x-1,y+1) > #doorIndex And floorMap(x+1,y-1) <= #doorIndex	:	shadowDim = 11	:	EndIf
				EndIf
				;LeftCorner
				If floorMap(x+1,y-1) <= #doorIndex And floorMap(x-1,y-1) > #doorIndex	:	shadowDim = 12	:	EndIf
			EndIf
		EndIf
	EndIf
	_EachActor(#hasImageP,0)
		If actor()\x = x And actor()\y = y And actor()\type = #patternActor And actor()\subtype = #shadowDimension
			If Not shadowDim
				markForKill(@actor())
			Else
				actor()\sort = shadowDim
			EndIf
			shadowDim = 0
			Break
		EndIf
	_EndEach()
	If shadowDim
		actorFactory(#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#True,#False,
		             0,#patternActor,#shadowDimension,0,shadowDim,0,0,#wallShadowDepth,#defaultVisibility,#False,#False,#False,#nullInteract,x,y,-1)
		actor()\alpha = 100
	EndIf
EndProcedure


Procedure rebuildDimensionChild()
	Define x, y
	Define dir
	Define child
	Define *current.ACTOR
	Dim matrix(xMax,yMax)
	Define eachCount
	
	For x = 0 To xMax
		For y = 0 To yMax
			If collisionMap(x,y) > #removableCollision
				matrix(x,y) = 1
			EndIf
		Next
	Next
	ForEach actor()
		If Not actor()\ident[#isDimensionP] And actor()\type = #obstacleActor And actor()\subtype = #oPillar
			matrix(actor()\x,actor()\y) = 2
		EndIf
	Next
	_EachActor(#hasImageP,#isDimensionP)
		If actor()\type = #obstacleActor
			If actor()\subtype = #oPillar
				child = actor()\index	
				x = actor()\x
				y = actor()\y
				If matrix(actor()\x,actor()\y+1) = 2	:	actor()\alpha = 150	:	EndIf
				*current = @actor()
				actorFactory(#True,#False,#False,#False,#False,#False,#False,#False,#True,#False,#False,#True,#False,
				             child,#obstacleActor,#oPillar,0,0,0,0,#dimensionDepth,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,x,y-1,-1)
				If Not matrix(x,y-1)	:	actor()\alpha = 200	:	EndIf
				actor()\frame = 1
				ChangeCurrentElement(actor(),*current)
			EndIf
		EndIf
	_EndEach()
	
	_EachActor(#hasImageP,#isDimensionP)
		If actor()\type = #teleportActor And actor()\subtype = #tPortal
			child = actor()\index	
			x = actor()\x
			y = actor()\y
			*current = @actor()
			actorFactory(#True,#False,#False,#False,#True,#False,#False,#False,#True,#False,#False,#True,#False,
			             child,#teleportActor,#tPortal,0,0,0,1,#dimensionDepth,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,x,y-1,-1)
			actorToAnimation(0,*current\alpha,*current\frameMax,*current\animTimer,*current\animLimit,0,0)
			ChangeCurrentElement(actor(),*current)
		EndIf
	_EndEach()
	
EndProcedure


Procedure calculateFOW()
	Define x, y
	Define dir
	
	Dim fowMap(#xMax,#yMax)
	For x = 0 To #xMax
		For y = 0 To #yMax
			fowMap(x,y) = -1
			If x <= xMax And y <= yMax
				If floorMap(x,y) > 0
					fowMap(x,y) = 0
					For dir = 1 To 4
						If x+xMod(dir) < 0 Or x+xMod(dir) > xMax Or y+yMod(dir) < 0 Or y +yMod(dir) > yMax
							Continue
						EndIf
						If floorMap(x+xMod(dir),y+yMod(dir)) = 0
							fowMap(x,y) + Pow(2,(dir-1))
						EndIf
					Next
				EndIf
			EndIf
		Next
	Next
EndProcedure


Procedure checkWallCorners(x,y,*subject.ACTOR)
	*subject\sort = 0
	If (floorMap(x-1,y+1) > #doorIndex Or floorMap(x-1,y) = #doorIndex) And (floorMap(x+1,y+1) > #doorIndex Or floorMap(x+1,y) = #doorIndex)
		*subject\sort = 3
	Else
		If floorMap(x-1,y+1) > #doorIndex Or floorMap(x-1,y) = #doorIndex	:	*subject\sort = 1	:	EndIf
		If floorMap(x+1,y+1) > #doorIndex Or floorMap(x+1,y) = #doorIndex	:	*subject\sort = 2	:	EndIf
	EndIf	
EndProcedure



Procedure drawStuff()
	Define x, y
	Define xPathPrev, yPathPrev, xPath, yPath
	Define radius, count
	Define xP, yP
	Define dir
	Define eachCount
	Define drawFloorTile
	Define rectRadius.f
	Define shadowAlpha
	Define lightFallOff
	
	
	

	ForEach viewPort()
		x = limit(*player\x+viewPort()\x,0,xMax)
		y = limit(*player\y+viewPort()\y,0,yMax)
		If bresenMap(x,y) And withinScreen(x,y)
			If baseMap(x,y) > 2
				For dir = 2 To 4
					_Dist(*player\x,*player\y,(x+xMod(dir)),(y+yMod(dir)))

					If bresenMap(x+xMod(dir),y+yMod(dir)) And floorMap(x+xMod(dir),y+yMod(dir)) > #doorIndex And distance <= radiance
						DisplayTransparentSprite(baseSPR(0),(x*#xTileSize)+_OffsetX()+xShake,(y*#yTileSize)+_OffsetY()+yShake)
						Break
					EndIf
				Next
			EndIf
			DisplayTransparentSprite(baseSPR(baseMap(x,y)),(x*#xTileSize)+_OffsetX()+xShake,(y*#yTileSize)+_OffsetY()+yShake)
		EndIf
	Next
	
	_EachActor(#hasImageP,0)
		If actor()\visible <> #fullVisibility
			If actor()\visible = #nullVisibility Or Not (withinView(actor()\x,actor()\y) And withinScreen(actor()\x,actor()\y)) Or
					(actor()\type = #patternActor And actor()\subtype = #shadowDimension And radiance = radianceMin)
				Continue
			EndIf
		EndIf
		If actor()\spriteIndex > 0
			DisplayTransparentSprite(externalSPR(actor()\spriteIndex),(actor()\x*#xTileSize)+_OffsetX()+actor()\xMicro+xShake,(actor()\y*#yTileSize)+_OffsetY()+actor()\yMicro+yShake,actor()\alpha)
		Else
			RotateSprite(actorSPR(actor()\type,actor()\subtype,actor()\class,actor()\sort,actor()\quality,actor()\status,actor()\frame),actor()\rotation,#PB_Absolute)
			DisplayTransparentSprite(actorSPR(actor()\type,actor()\subtype,actor()\class,actor()\sort,actor()\quality,actor()\status,actor()\frame),(actor()\x*#xTileSize)+_OffsetX()+actor()\xMicro+xShake,(actor()\y*#yTileSize)+_OffsetY()+actor()\yMicro+yShake,actor()\alpha)
		EndIf
		;		EndIf
		;			StartDrawing(ScreenOutput())
		;			DrawText((actor()\x*#xTileSize)+_OffsetX(),(actor()\y*#yTileSize)+_OffsetY(),Str(actor()\index),color(#cDark),color(#cLight))
		;			StopDrawing()
	_EndEach()

	
	If ListSize(projectile())
		xP = limit(((projectile()\x-xMargin)/#xTileSize)+(xViewCenter-xMaxView),0,xMax)
		yP = limit(((projectile()\y-yMargin)/#yTileSize)+(yViewCenter-yMaxView),0,yMax)
		If withinView(xP,yP) And withinScreen(xP,yP)
			DisplayTransparentSprite(projectileSPR,projectile()\x+xShake,projectile()\y+yShake)
		EndIf
	EndIf
	
	
	ForEach coverTile()
		DisplayTransparentSprite(shadeSPR,(coverTile()\x*#xTileSize)+_OffsetX()+xShake,(coverTile()\y*#yTileSize)+_OffsetY()+yShake,255)
;		DisplayTransparentSprite(defaultPainSPR,(coverTile()\x*#xTileSize)+_OffsetX()+xShake,(coverTile()\y*#yTileSize)+_OffsetY()+yShake,255)
;		DisplayTransparentSprite(shadeSPR,(coverTile()\x*#xTileSize)+_OffsetX()+xShake,(coverTile()\y*#yTileSize)+_OffsetY()+yShake,getShadowAlpha(coverTile()\x,coverTile()\y,-1))
	Next
	
	ForEach viewPort()
		x = *player\x+viewPort()\x
		y = *player\y+viewPort()\y
		If x < 0 Or x > xMax Or y < 0 Or y > yMax
			Continue
		EndIf
		If withinView(x,y) And withinScreen(x,y)
			shadowAlpha = getShadowAlpha(x,y,radiance)
			If shineMap(x,y) ;And withinScreen(x,y)
				If shineMap(x,y) < 1000	:	lightFallOff = 100	:	EndIf
				If shineMap(x,y) < 100	:	lightFallOff = 65	:	EndIf
				If shineMap(x,y) < 10	:	lightFallOff = 30	:	EndIf
				If shineMap(x,y) > 1000	:	lightFallOff = 135	:	EndIf
				shadowAlpha = limit(shadowAlpha-lightFallOff,0,255)
				DisplayTransparentSprite(shineSPR,(x*#xTileSize)+_OffsetX()+xShake,(y*#yTileSize)+_OffsetY()+yShake,(lightFallOff/2)-radiance)
			EndIf
			DisplayTransparentSprite(shadeSPR,(x*#xTileSize)+_OffsetX()+xShake,(y*#yTileSize)+_OffsetY()+yShake,shadowAlpha)
		EndIf
	Next
	
	For x = limit(*player\x-lineOfSight,0,xMax) To limit(*player\x+lineOfSight,0,xMax)
		For y = limit(*player\y-lineOfSight,0,yMax) To limit(*player\y+lineOfSight,0,yMax)
			rectRadius = Abs(*player\x - x)
			If Abs(*player\y-y) > rectRadius	:	rectRadius = Abs(*player\y - y) : EndIf
			rectRadius+0.5
			_Dist(*player\x,*player\y,x,y)
			If fowMap(x,y) > -1
			;(bresenMap(x,y) And distance > radiance) Or
			  If hasMap And exploreMap(x,y) And rectRadius <= radiance And (Not bresenMap(x,y) Or distance > radiance)
				DisplayTransparentSprite(mappedSPR(fowMap(x,y)),(x*#xTileSize)+_OffsetX()+xShake,(y*#yTileSize)+_OffsetY()+yShake,90)
			EndIf
			EndIf
		Next
	Next

	
	
	If Not isMonsterTurn And Not hideMouse And (xMouse > -1 And yMouse > -1)
		If canInteractMap(xMouse,yMouse)
			DisplayTransparentSprite(interactionRectangleSPR,(xMouse*#xTileSize)+_OffsetX(),(yMouse*#yTileSize)+_OffsetY(),100)
		EndIf

		If ListSize(aStarPath()) > 1 And (Not holdLeft)
			ForEach aStarPath()
				If ListIndex(aStarPath())  And (Not collisionMap(aStarPath()\x,aStarPath()\y)) And withinView(aStarPath()\x,aStarPath()\y) And withinScreen(aStarPath()\x,aStarPath()\y)
					DisplayTransparentSprite(pathNodeSPR,(aStarPath()\x*#xTileSize)+_OffsetX(),(aStarPath()\y*#yTileSize)+_OffsetY(),33)
				EndIf
				x = aStarPath()\x
				y = aStarPath()\y
			Next
		EndIf
	EndIf
	
	
	_EachActor(#isGadgetP,0)
		If actor()\spriteIndex > 0
			DisplayTransparentSprite(externalSPR(actor()\spriteIndex),(actor()\x*#xTileSize)+_OffsetX()+actor()\xMicro+xShake,(actor()\y*#yTileSize)+_OffsetY()+actor()\yMicro+yShake,actor()\alpha)
		Else
			DisplayTransparentSprite(actorSPR(actor()\type,actor()\subtype,actor()\class,actor()\sort,actor()\quality,actor()\status,actor()\frame),(actor()\x*#xTileSize)+_OffsetX()+actor()\xMicro+xShake,(actor()\y*#yTileSize)+_OffsetY()+actor()\yMicro+yShake,actor()\alpha)
		EndIf
	_EndEach()
EndProcedure


Procedure getShadowAlpha(x,y,rad.f)
	_Dist(x,y,*player\x,*player\y)
	If radiance = radianceMin
		Select distance
			Case 0	:	ProcedureReturn 210
			Default	:	ProcedureReturn 225
		EndSelect
	EndIf
	ProcedureReturn limitFloat((giveGauss(distance+((radianceMax-rad)+1))*sightDecay),0,255)
EndProcedure



Procedure drawStatusBar()
;	DisplaySprite(statBarSPR,xOffsetStatBar,yOffsetStatBar)

	
	;If IsScreenActive()
		If StartDrawing(ScreenOutput())	
			
			DrawingFont(FontID(font(3))) 
			
;			_TText()
;			DrawText(xOffsetSidebar+20,#yRes-90,"Floor: "+Str(dFloor),color(#cLight))
;			DrawText(xOffsetSidebar+20,#yRes-60,Str(*player\x)+","+Str(*player\y),color(#cLight))
;			DrawText(xOffsetSidebar+120,#yRes-30,Str(cs1)+","+Str(cs2),color(#cLight))
			;		For x = 0 To #actorPointerMax
			;			DrawText(5,20+(x*20),Str(actorCounter(x)),color(#cLight))
			;		Next
			;		DrawingFont(FontID(font(0))) 
;					ForEach freeField()
;						If bresenMap(freeField()\x,freeField()\y)
;							If collisionMap(freeField()\x,freeField()\y) < #pathCollision
;								DrawText((freeField()\x*#xTileSize)+_OffsetX(),(freeField()\y*#yTileSize)+_OffsetY(),Str(floorMap(freeField()\x,freeField()\y)),color(#cBlack),color(#cLight))
;							EndIf
;						EndIf
;					Next
			;		_EachActor(#isMonsterP)
			;			If isOnScreen(actor()\x,actor()\y) ;And (Not actor() = *player)
			;				DrawText((actor()\x*#xTileSize)+_OffsetX(),(actor()\y*#yTileSize)+_OffsetY(),Str(actor()\panic),color(#cBlack),color(#cLight))
			;				DrawText((actor()\x*#xTileSize)+_OffsetX(),(actor()\y*#yTileSize)+_OffsetY(),Str(actor()\index),color(#cBlack),color(#cLight))
			;			EndIf
			;		_EndEach()
			
			StopDrawing()
		EndIf
	;EndIf
EndProcedure


Procedure updateMapView(xMapCenter,yMapCenter,viewMapX,viewMapY)
	Define x, y
	Define eachCount
	Define dir
	Define xSpace = ImageWidth(asciiIMG(0))
	Define ySpace = ImageHeight(asciiIMG(0))
	Define mapOffsetX = xMapCenter-viewMapX
	Define mapOffsetY = yMapCenter-viewMapY
	
	If IsSprite(mapOverlaySPR)
		FreeSprite(mapOverlaySPR)
	EndIf
	mapOverlaySPR = CreateSprite(#PB_Any,((viewMapX*2)+1)*xSpace,((viewMapY*2)+1)*ySpace)
	mapOffsetX = limit(xMapCenter-viewMapX,0,xMax)
	mapOffsetY = limit(yMapCenter-viewMapY,0,yMax)
	If StartDrawing(SpriteOutput(mapOverlaySPR))
		For x = limit(xMapCenter-viewMapX,0,xMax) To limit(xMapCenter+viewMapX,0,xMax)
			For y = limit(yMapCenter-viewMapY,0,yMax) To limit(yMapCenter+viewMapY,0,yMax)
				If Not exploreMap(x,y)
					Continue
				EndIf
				
				If floorMap(x,y) = 0
					DrawImage(ImageID(asciiIMG(#asciiIMGwall)),(x-mapOffsetX)*xSpace,(y-mapOffsetY)*ySpace)
				Else
					If floorMap(x,y) = #doorIndex
						_EachActor(#isDoorP,#Null)
							If actor()\x = x And actor()\y = y
								If actor()\subtype = #regularDoor
									DrawImage(ImageID(asciiIMG(actor()\class+(actor()\status*(#maxLockedSort+1)))),(x-mapOffsetX)*xSpace,(y-mapOffsetY)*ySpace)
									Break
								EndIf
							EndIf
						_EndEach()
					Else
						DrawImage(ImageID(asciiIMG(#asciiIMGfree)),(x-mapOffsetX)*xSpace,(y-mapOffsetY)*ySpace)
						_EachActor(#isTriggerP,#Null)
							If actor()\x = x And actor()\y = y And actor()\type = #teleportActor And actor()\subtype = #tPortal
								DrawImage(ImageID(asciiIMG(#asciiIMGportal)),(x-mapOffsetX)*xSpace,(y-mapOffsetY)*ySpace)
								Break
							EndIf
						_EndEach()
					EndIf
				EndIf
			Next
		Next
		StopDrawing()
	EndIf
EndProcedure


Procedure drawInventory()
	Define x, y
	Define count
	Define invType, invLoc
	
	If isInvActive(#floorInv)
		DisplayTransparentSprite(floorInvSPR,invOffsetX(#floorInv),invOffsetY(#floorInv))
	EndIf
	ForEach slot()
		x = invOffsetX(slot()\parentInv) + slot()\x
		y = invOffsetY(slot()\parentInv) + slot()\y
		If slot()\parentInv <> #floorInv
			DisplayTransparentSprite(slotSPR(slot()\parentInv),x,y)	
			If slot()\index = 0
				DisplaySprite(sleepingSlotSPR,x,y)
			EndIf	
		EndIf
		If Not isInvActive(#monsterInv) Or slot()\parentInv = #equipInv
			Continue
		EndIf
		
		If slot()\x = 0																:	DisplayTransparentSprite(invBorderSPR(1),x-SpriteWidth(invBorderSPR(1)),y) : EndIf			
		If slot()\y = 0																:	DisplayTransparentSprite(invBorderSPR(0),x,y-SpriteHeight(invBorderSPR(0))) : EndIf
		If slot()\x/SpriteWidth(slotSPR(#monsterInv)) = slotsColumn(#monsterInv)-1	:	DisplayTransparentSprite(invBorderSPR(2),x+SpriteWidth(invBorderSPR(2)),y) : EndIf
		If slot()\y/SpriteHeight(slotSPR(#monsterInv)) = slotsRow(#monsterInv)-1	:	DisplayTransparentSprite(invBorderSPR(3),x,y+SpriteHeight(invBorderSPR(3))) : EndIf
	Next
	
	ForEach invTab()
		DisplayTransparentSprite(invTabSPR(invTab()\isActive),invTab()\x,invTab()\y)
	Next

	
	
	For count = 1 To ArraySize(*invPointer())
		If *invPointer(count) <> #Null
			invType = getInventoryIndex(count)
			invLoc = *invPointer(count)\invLocation-(invSlotStart(invType)-1)-(slotsPerTab(invType)*currentTab(invType))
			*invPointer(count)\frame = 1
			DisplayTransparentSprite(actorSPR(#itemActor,*invPointer(count)\subtype,*invPointer(count)\class,*invPointer(count)\sort,*invPointer(count)\quality,*invPointer(count)\status,*invPointer(count)\frame),invOffsetX(invType)+slotX(invType,invLoc)+itemOffsetX(invType),invOffsetY(invType)+slotY(invType,invLoc)+itemOffsetY(invType))
			*invPointer(count)\frame = 0
			If *invPointer(count)\stacks > 1
				If StartDrawing(ScreenOutput())
					DrawingMode(#PB_2DDrawing_Transparent)
					DrawText(invOffsetX(invType)+slotX(invType,invLoc)+45,invOffsetY(invType)+slotY(invType,invLoc)+37,Str(*invPointer(count)\stacks),color(#cMurky))
					StopDrawing()
				EndIf
			EndIf
			
		
			
			If *selectedItem = *invPointer(count)
				DisplayTransparentSprite(selectedSlotSPR(invType,1),slotX(invType,invLoc)+invOffsetX(invType)+5,slotY(invType,invLoc)+invOffsetY(invType)+5,125)
			EndIf
			If *carryItem = *invPointer(count)
				DisplayTransparentSprite(selectedSlotSPR(invType,0),slotX(invType,invLoc)+invOffsetX(invType),slotY(invType,invLoc)+invOffsetY(invType))
			EndIf
		EndIf
	Next
	
;	ForEach slot()
;		If StartDrawing(ScreenOutput())
;			DrawingMode(#PB_2DDrawing_Transparent)
;			DrawText(slot()\x,slot()\y,Str(*player\inventory[slot()\index]),color(#cLight))
;			StopDrawing()
;		EndIf	
;	Next
	
	
	If isInvActive(#monsterInv)
		If MouseX() >= closeX And MouseX() <= closeX+SpriteWidth(closeInvSPR(0)) And MouseY() > closeY And MouseY() < closeY+SpriteHeight(closeInvSPR(0))
			DisplaySprite(closeInvSPR(1),closeX,closeY)
		Else
			DisplaySprite(closeInvSPR(0),closeX,closeY)
		EndIf
	EndIf
EndProcedure


Procedure switchMouseSprite(thisSPR)
	If IsSprite(mouseSPR)
		FreeSprite(mouseSPR)
	EndIf
	mouseSPR = CopySprite(thisSPR,#PB_Any)
EndProcedure



Procedure drawMouse(alpha)
	If Not isMonsterTurn And Not hideMouse And Not holdLeft And mouseStatus = 0
		DisplayTransparentSprite(mouseSPR,MouseX()-(#xTileSize/2),MouseY()-(#xTileSize/2),alpha)
	EndIf
EndProcedure


Procedure spriteFactory()
	Define count
	Define a, b, c, d, e, f, g
	Define fillColor
	
	If Not IsSprite(statBarSPR)
		statBarSPR = CreateSprite(#PB_Any,xStatBarSize,yStatBarSize)
		If StartDrawing(SpriteOutput(statBarSPR))
			Box(0,0,xStatBarSize,yStatBarSize,color(#cStone))
			StopDrawing()
		EndIf
	EndIf
	
	_LoadImg("inventorySlot.png")
	For c = 1 To #invTypeMax
		If Not IsSprite(slotSPR(c))
			slotSPR(c) = CreateSprite(#PB_Any,ImageWidth(pic)/#invTypeMax,ImageHeight(pic))
			If StartDrawing(SpriteOutput(slotSPR(c)))
				DrawImage(ImageID(pic),((c-1)*-1)*SpriteWidth(slotSPR(c)),0)
				StopDrawing()
			EndIf
		EndIf
	Next
	
	_LoadImg("inventoryBorder.png")
	For c = 0 To 3
		If Not IsSprite(invBorderSPR(c))
			invBorderSPR(c) = CreateSprite(#PB_Any,ImageWidth(pic)/4,ImageHeight(pic))
			If StartDrawing(SpriteOutput(invBorderSPR(c)))
				DrawImage(ImageID(pic),(c*-1)*SpriteWidth(invBorderSPR(c)),0)
				StopDrawing()
			EndIf
		EndIf
	Next
	_LoadImg("floorInventory.png")
	For c = 0 To 7
		If IsImage(floorSlotIMG(c))
			FreeImage(floorSlotIMG(c))
		EndIf
		floorSlotIMG(c) = GrabImage(pic,#PB_Any,c*(ImageWidth(pic)/8),0,ImageWidth(pic)/8,ImageHeight(pic))
	Next
	
	If Not IsSprite(sleepingSlotSPR)
		sleepingSlotSPR = CreateSprite(#PB_Any,SpriteWidth(slotSPR(#monsterInv)),SpriteHeight(slotSPR(#monsterInv)))
		If StartDrawing(SpriteOutput(sleepingSlotSPR))
			Box(0,0,SpriteWidth(sleepingSlotSPR),SpriteHeight(sleepingSlotSPR),color(#cSand))
			StopDrawing()
		EndIf
	EndIf
	
	For count = 1 To #invTypeMax
		If Not IsSprite(selectedSlotSPR(count,0))
			selectedSlotSPR(count,0) = CreateSprite(#PB_Any,SpriteWidth(slotSPR(count)),SpriteHeight(slotSPR(count)))
		EndIf
		If Not IsSprite(selectedSlotSPR(count,1))
			selectedSlotSPR(count,1) = CreateSprite(#PB_Any,SpriteWidth(slotSPR(count))-10,SpriteHeight(slotSPR(count))-10)
			If StartDrawing(SpriteOutput(selectedSlotSPR(count,1)))
				RoundBox(0,0,SpriteWidth(selectedSlotSPR(count,1)),SpriteHeight(selectedSlotSPR(count,1)),5,5,color(#cGrass))
				StopDrawing()
			EndIf
		EndIf
	Next
	
	
	For count = 0 To 1
		If Not IsSprite(closeInvSPR(count))
			closeInvSPR(count) = CreateSprite(#PB_Any,25,25)	
			If StartDrawing(SpriteOutput(closeInvSPR(count)))
				Select count
					Case 0	:	fillColor = color(#cDark)
					Case 1	:	fillColor = color(#cSand)
				EndSelect
				
				Box(0,0,SpriteWidth(closeInvSPR(count)),SpriteHeight(closeInvSPR(count)),fillColor)
				_DMode0()
				Box(0,0,SpriteWidth(closeInvSPR(count)),SpriteHeight(closeInvSPR(count)),color(#cLight))
				LineXY(4,4,SpriteWidth(closeInvSPR(count))-4,SpriteHeight(closeInvSPR(count))-4,color(#cBlood))
				LineXY(5,4,SpriteWidth(closeInvSPR(count))-4,SpriteHeight(closeInvSPR(count))-5,color(#cBlood))
				LineXY(4,5,SpriteWidth(closeInvSPR(count))-5,SpriteHeight(closeInvSPR(count))-4,color(#cBlood))
				
				LineXY(SpriteWidth(closeInvSPR(count))-4,4,4,SpriteHeight(closeInvSPR(count))-4,color(#cBlood))
				LineXY(SpriteWidth(closeInvSPR(count))-5,4,4,SpriteHeight(closeInvSPR(count))-5,color(#cBlood))
				LineXY(SpriteWidth(closeInvSPR(count))-4,5,5,SpriteHeight(closeInvSPR(count))-4,color(#cBlood))
				StopDrawing()
			EndIf
		EndIf
	Next
	
	;Inventory Tabs
	For count = 0 To 1
		If Not IsSprite(invTabSPR(count))
			invTabSPR(count) = CreateSprite(#PB_Any,50,30)
			Select count
				Case 0
					If StartDrawing(SpriteOutput(invTabSPR(0)))
						Box(0,10,25,20,color(#cEarth))
						LineXY(0,10,0,30,color(#cWood))
						LineXY(0,30,45,30,color(#cWood))
						LineXY(0,10,25,10,color(#cWood))
						LineXY(25,10,45,30,color(#cWood))
						FillArea(35,28,-1,color(#cEarth))
						StopDrawing()
					EndIf
				Case 1
					If StartDrawing(SpriteOutput(invTabSPR(1)))
						Box(0,0,30,40,color(#cPearl))
						LineXY(0,0,0,30,color(#cWood))
						LineXY(0,30,50,30,color(#cWood))
						LineXY(0,0,30,0,color(#cWood))
						LineXY(30,0,50,30,color(#cWood))
						FillArea(45,25,-1,color(#cPearl))
						StopDrawing()
					EndIf
			EndSelect
		EndIf
	Next

	_LoadImg("base.png")
	For count = 0 To 5
		If Not IsSprite(baseSPR(count))
			baseSPR(count) = CreateSprite(#PB_Any,#xTileSize,#yTileSize)		
			If StartDrawing(SpriteOutput(baseSPR(count)))
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)
				StopDrawing()
			EndIf
		EndIf
	Next
	_LoadImg("wallPattern.png")
	For d = 0 To 2
		If Not IsSprite(actorSPR(#patternActor,#wallPattern,0,d,0,0,0))
			_NewSprite(#patternActor,#wallPattern,0,d,0,0,0)
				DrawImage(ImageID(pic),(d*-1)*#xTileSize,0)
			_EndSprite()
		EndIf
	Next
	_LoadImg("wallDimension.png")
	For d = 0 To 3
		If Not IsSprite(actorSPR(#patternActor,#wallDimension,0,d,0,0,0))
			_NewSprite(#patternActor,#wallDimension,0,d,0,0,0)
				DrawImage(ImageID(pic),(d*-1)*#xTileSize,0)
			_EndSprite()
		EndIf
	Next
	_LoadImg("wallShadow.png")
	For d = 1 To 12
		If Not IsSprite(actorSPR(#patternActor,#shadowDimension,0,d,0,0,0))
			_NewSprite(#patternActor,#shadowDimension,0,d,0,0,0)
				DrawImage(ImageID(pic),((d-1)*-1)*#xTileSize,0)
			_EndSprite()
		EndIf
	Next
	
	_LoadImg("mapped.png")
	For count = 0 To 15
		If Not IsSprite(mappedSPR(count))
			mappedSPR(count) = CreateSprite(#PB_Any,#xtileSize,#yTileSize)
			If StartDrawing(SpriteOutput(mappedSPR(count)))
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)
				StopDrawing()
			EndIf
		EndIf
	Next
	If Not IsSprite(mapSPR)
		mapSPR = LoadSprite(#PB_Any,"RESSOURCES/map.png")
	EndIf
	;asciiIMG
	For count = 0 To #asciiMax
		asciiIMG(count) = CreateImage(#PB_Any,15,15)
		If StartDrawing(ImageOutput(asciiIMG(count)))
			_TText()
			DrawingFont(FontID(font(4)))
			FillArea(1,1,-1,color(#cLight))
			Select count
				Case #asciiIMGdoor0Closed, #asciiIMGdoor0Open
					DrawText(1,-1,"/",lockedColor(0))
				Case #asciiIMGdoor1Closed, #asciiIMGdoor2Closed, #asciiIMGdoor3Closed, #asciiIMGdoor4Closed
					DrawText(0,-3,"x",lockedColor(count))
				Case #asciiIMGdoor1Open, #asciiIMGdoor2Open, #asciiIMGdoor3Open, #asciiIMGdoor4Open
					DrawText(0,-1,"+",lockedColor(count-#maxLockedSort-1))
				Case #asciiIMGportal
					DrawText(0,-1,"O",color(#cGold))
				Case #asciiIMGfree
					DrawText(1,-7,".",color(#cWood))
				Case #asciiIMGwall
					DrawText(1,-1,"#",color(#cDark))
			EndSelect
			;			_DMode0()
			;			Box(0,0,15,15,color(#cDark))
			StopDrawing()
		EndIf
	Next	
	If Not asciiPlayerSPR
		asciiPlayerSPR = CreateSprite(#PB_Any,15,15)
		If StartDrawing(SpriteOutput(asciiPlayerSPR))
			_TText()
			DrawingFont(FontID(font(4)))
			FillArea(1,1,-1,color(#cLight))
			DrawText(1,0,"@",color(#cDark))
			DrawText(0,-1,"@",color(#cBlood))
			StopDrawing()
		EndIf
	EndIf
	
	If Not IsSprite(interactionRectangleSPR)
		interactionRectangleSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(interactionRectangleSPR))
			Box(0,0,#xTileSize,#yTileSize,color(#cFire))
			StopDrawing()
		EndIf
	EndIf
	
	If Not IsSprite(mouseSPR)
		mouseSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
	EndIf
	If Not IsSprite(cursorSPR)
		cursorSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(cursorSPR))
			Circle(#xTileSize/2,#yTileSize/2,5,color(#cTree))
			_DMode0()
			Circle(#xTileSize/2,#yTileSize/2,10,color(#cGrass))
			Circle(#xTileSize/2,#yTileSize/2,11,color(#cTree))
			Circle(#xTileSize/2,#yTileSize/2,5,color(#cGrass))
			Circle(#xTileSize/2,#yTileSize/2,6,color(#cGrass))
			StopDrawing()
		EndIf
	EndIf
	
	If Not IsSprite(pathNodeSPR)
		pathNodeSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(pathNodeSPR))
			Circle(#xTileSize/2,#yTileSize/2,10,color(#cDark))
			StopDrawing()
		EndIf
	EndIf
	
	If Not IsSprite(projectileSPR)
		projectileSPR = CreateSprite(#PB_Any,6,6)
		If StartDrawing(SpriteOutput(projectileSPR))
			Box(0,0,6,6,color(#cWhite))
			Circle(3,3,3,color(#cDark))
			StopDrawing()
		EndIf
		TransparentSpriteColor(projectileSPR,color(#cWhite))
	EndIf
	
	If Not IsSprite(shadeSPR)
		shadeSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize,#PB_Sprite_AlphaBlending)
	EndIf
	
	;Shine
	If Not IsSprite(shineSPR)
		shineSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize,#PB_Sprite_AlphaBlending)
		If StartDrawing(SpriteOutput(shineSPR))
			Box(0,0,#xTileSize,#yTileSize,color(#cSkin))
			StopDrawing()
		EndIf
	EndIf
	
	;Pain
	If Not IsSprite(defaultPainSPR)
		defaultPainSPR = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(defaultPainSPR))
			Circle(#xTileSize/3,#yTileSize/3,8,color(#cBlood))
			Circle(#xTileSize-(#xTileSize/3),#yTileSize-(#yTileSize/3)-7,9,color(#cBlood))
			Circle(#xTileSize/3,#yTileSize-(#yTileSize/3),10,color(#cBlood))
			StopDrawing()
		EndIf
	EndIf
	
	
	
	
	;ActorSprites
	
	


	
	;Spieler
	For a = 0 To 1
		_LoadImg("hoplite.png")
		_NewSprite(#monsterActor,0,0,0,0,a,0)
			DrawImage(ImageID(pic),(a*-1)*#xTileSize,0)
		_EndSprite()
	Next
	
	
	
	;Monster
	For a = 0 To 1
		_NewSprite(#monsterActor,1,0,0,0,a,0)
			Box(0,0,#xTileSize,#yTileSize,color(#cBlack))
			Circle(#xTileSize/2,(#yTileSize/2)+8,15,color(#cDark))
			DrawingMode(#PB_2DDrawing_Transparent)
			DrawingFont(FontID(font(1)))
			DrawText(11,14,"^^",color(#cShiny))
			DrawText(15,17,"_",color(#cShiny))
		_EndSprite()
		;Fliegendes Monster
		_NewSprite(#monsterActor,1,1,0,0,a,0)
			Box(0,0,#xTileSize,#yTileSize,color(#cBlack))
			Box(3,3,13,13,color(#cSand))
			Box(27,3,13,13,color(#cSand))
			_DMode0()
			Box(3,3,13,13,color(#cDark))
			Box(27,3,13,13,color(#cDark))
			_DMode1()
			Circle(#xTileSize/2,(#yTileSize/2)-5,12,color(#cWood))
			_DMode0()
			Circle(#xTileSize/2,(#yTileSize/2)-5,12,color(#cDark))
			DrawingMode(#PB_2DDrawing_Transparent)
			DrawingFont(FontID(font(1)))
			DrawText(12,6,"^^",color(#cDark))
			;		DrawText(15,9,"_",color(#cDark))
		_EndSprite()
		;Ranged Monster
		_NewSprite(#monsterActor,1,2,0,0,a,0)
			Box(0,0,#xTileSize,#yTileSize,color(#cBlack))
			Box(15,10,10,30,color(#cGrass))
			Box(5,22,30,5,color(#cGrass))
			Circle(#xTileSize/2,(#yTileSize/2)-7,10,color(#cTree))
			DrawingMode(#PB_2DDrawing_Transparent)
			DrawingFont(FontID(font(1)))
			DrawText(12,5,"oo",color(#cDark))
		_EndSprite()
		
	Next
	
	;Säule
	_LoadImg("pillar.png")
	For c = 0 To 1
		_NewSprite(#obstacleActor,#oPillar,0,0,0,0,c)
			DrawImage(ImageID(pic),(c*-1)*#xTileSize,0)
		_EndSprite()
	Next
	;Brazier
	_LoadImg("brazier.png")
	For count = 0 To 1
		_NewSprite(#obstacleActor,#oBrazier,0,0,0,count,0)
			DrawImage(ImageID(pic),0,0)
		_EndSprite()
	Next
	;Flammen
	_LoadImg("brazierFlame.png")
	For c = 0 To 3
		_NewSprite(#animationActor,#brazierAnim,0,0,0,0,c)
			DrawImage(ImageID(pic),(c*-1)*#xTileSize,0)
		_EndSprite()
	Next	
	
	;Stein
	If Not IsSprite(actorSPR(#obstacleActor,#oStone,0,0,0,0,0))
		actorSPR(#obstacleActor,#oStone,0,0,0,0,0) = LoadSprite(#PB_Any,"RESSOURCES/stone.png")
	EndIf
	
	_LoadImg("unlockedDoor.png")
	;Tür
	For b = 0 To 1
		_NewSprite(#doorActor,#regularDoor,0,0,0,b,0)
			DrawImage(ImageID(pic),(b*-1)*#xTileSize,0)
		_EndSprite()
	Next
	_LoadImg("lockedDoor.png")
	count = 0
	For a = 1 To #maxLockedSort
		For b = 0 To 1
			_NewSprite(#doorActor,#regularDoor,a,0,0,b,0)
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)		
			_EndSprite()
			count +1
		Next
	Next

	;Teleporter
	_LoadImg("portal.png")
	count = 0
	For a = 0 To 4
		For b = 0 To 1
			_NewSprite(#teleportActor,#tPortal,0,0,0,b,a)
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)
			_EndSprite()
			count +1
		Next
	Next
	
	
	;Items
	
	;LootContainer
	If Not IsSprite(actorSPR(#itemActor,#containerItem,#lootCont,0,0,0,0))
		actorSPR(#itemActor,#containerItem,#lootCont,0,0,0,0) = LoadSprite(#PB_Any,"RESSOURCES/container.png")
	EndIf
	
	
	
	;Melee Weapons
	For b = 0 To #meleeWeaponMax
		_LoadImg("melee0"+Str(b)+".png")
		For a = 0 To 1
			_NewSprite(#itemActor,#equipableItem,#meleeItem,b,0,0,a)
				DrawImage(ImageID(pic),(a*-1)*#xTileSize,0)
			_EndSprite()
		Next
	Next
	
	
	;Food-Items
	For f = 0 To #foodMax
		_LoadImg("food0"+Str(f)+".png")
		For a = 0 To 1
			_NewSprite(#itemActor,#consumableItem,#foodClass,f,0,0,a)
				DrawImage(ImageID(pic),(a*-1)*#xTileSize,0)
			_EndSprite()
		Next
	Next

	
	;Schlüssel
	_LoadImg("itemKey.png")
	count = 0
	For c = 1 To #maxLockedSort
		For a = 0 To 1
			_NewSprite(#itemActor,#keyItem,c,0,0,0,a)
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)
				count +1
			_EndSprite()
		Next
	Next
	
	
	;Map
	_LoadImg("itemMap.png")
	count = 0
	For c = 0 To 2
		For a = 0 To 1
			_NewSprite(#itemActor,#staticItem,#mapItem,c,0,0,a)
				DrawImage(ImageID(pic),(count*-1)*#xTileSize,0)
				count +1
			_EndSprite()
		Next
	Next	
	
	
	For a = 0 To #actorTypeMax
		For b = 0 To #actorSubtypeMax
			For c = 0 To #actorClassMax
				For d = 0 To #actorSortMax
					For e = 0 To #actorQualityMax
						For f = 0 To #actorStatusMax
							For g = 0 To #animationFrameMax
								If IsSprite(actorSPR(a,b,c,d,e,f,g)) And 
									TransparentSpriteColor(actorSPR(a,b,c,d,e,f,g),color(#cBlack))
								EndIf
							Next
						Next
						
					Next
				Next
			Next
		Next
	Next
	For d = 1 To 12
		TransparentSpriteColor(actorSPR(#patternActor,#shadowDimension,0,d,0,0,0),color(#cBlood))
	Next
	
	FreeImage(pic)
EndProcedure


Procedure createHitEffect(*target.ACTOR,damage)
	Define spriteIndex
	Define xDice, yDice
	Define isChild
	Define animKillLimit = 600
	Define width, height
	
	If *target\hp > 0
		isChild = *target\index
		animKillLimit = 400
	EndIf
	spriteIndex = iniExternalSprite()
	externalSPR(spriteIndex) = CopySprite(defaultPainSPR,#PB_Any)
	actorFactory(#True,#False,#False,#False,#True,#True,#False,#False,#True,#False,#False,#False,#False,
	             isChild,#animationActor,#extAnim,0,0,0,0,*target\drawPriority+2,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,*target\x,*target\y,-1)
	actorToAnimation(spriteIndex,125,0,0,0,ElapsedMilliseconds(),animKillLimit)
	
	
	
	spriteIndex = iniExternalSprite()
	If *target\hp <= 0	
		externalSPR(spriteIndex) = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(externalSPR(spriteIndex)))
			DrawingMode(#PB_2DDrawing_Transparent)
			DrawingFont(FontID(font(8)))
			DrawText(7,2,"X",colOr(#cDark))
			DrawText(5,0,"X",color(#cBlood))
			StopDrawing()
		EndIf
		actorFactory(#True,#False,#False,#False,#True,#True,#False,#False,#True,#False,#False,#False,#False,
		             isChild,#animationActor,#extAnim,0,0,0,0,*target\drawPriority+3,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,*target\x,*target\y,-1)
		actorToAnimation(spriteIndex,255,0,0,0,ElapsedMilliseconds(),animKillLimit)
	Else
		width = #xTileSize
		height = #yTileSize
		If StartDrawing(ScreenOutput())
			DrawingFont(FontID(font(1)))
			width = TextWidth(Str(damage))
			height = TextHeight(Str(damage))
			StopDrawing()
		EndIf
		externalSPR(spriteIndex) = CreateSprite(#PB_Any,width,height)
		If StartDrawing(SpriteOutput(externalSPR(spriteIndex)))
			DrawingFont(FontID(font(1)))
			DrawingMode(#PB_2DDrawing_Transparent)	
			DrawText(1,1,Str(damage),color(#cDark))
			DrawText(0,0,Str(damage),color(#cBlood))
			StopDrawing()
		EndIf
		
		actorFactory(#False,#False,#False,#False,#True,#True,#False,#False,#True,#False,#False,#False,#True,
		             isChild,#animationActor,#extAnim,0,0,0,0,*target\drawPriority+3,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,*target\x,*target\y,-1)
		actorToAnimation(spriteIndex,255,0,0,0,ElapsedMilliseconds(),animKillLimit)
		If StartDrawing(ScreenOutput())
			actor()\xMicro = limit(Random(#xTileSize)-width,0,#xTileSize)
			actor()\yMicro = limit(Random(#yTileSize)-height,0,#yTileSize)
			StopDrawing()
		EndIf
	EndIf	
EndProcedure


Procedure iniExternalSprite()
	Define count
	
	For count = 1 To extSpriteCounter
		If extSpriteLib(count) = #False
			extSpriteLib(count) = #True
			ProcedureReturn count
		EndIf
	Next
	
	extSpriteCounter +1
	ReDim extSpriteLib(extSpriteCounter)
	ReDim externalSPR(extSpriteCounter)
	extSpriteLib(extSpriteCounter) = #True
	If IsSprite(externalSPR(extSpriteCounter))
		FreeSprite(externalSPR(extSpriteCounter))
	EndIf
	
	ProcedureReturn extSpriteCounter
EndProcedure


Procedure shakeDoorAnimation(*subject.ACTOR,shakeDuration)
	Define timer = ElapsedMilliseconds()
	
	If Not withinView(*subject\x,*subject\y)
		ProcedureReturn #False
	EndIf
	
	Repeat
		*subject\xMicro = Random(4)-2
		*subject\yMicro = Random(4)-2
		_Display()
		_MyFlip()
	Until ElapsedMilliseconds() - timer > shakeDuration
	*subject\xMicro = 0;Random(4)-2
	*subject\yMicro = 0;Random(4)-2
	
	ChangeCurrentElement(actor(),*subject)
	ProcedureReturn #True
EndProcedure


Procedure projectileAnimation(*origin.ACTOR,*target.ACTOR)
	Define x0, y0, x1, y1
	Define count
	Define shootDir = 1
	Define bulletStep
	Define timer
	Define event
	Define speed
	
	_Dist(*origin\x,*origin\y,*target\x,*target\y)
	
	x0 = (*origin\x*#xTileSize)+(#xTileSize/2)+_OffsetX()
	y0 = (*origin\y*#yTileSize)+(#yTileSize/2)+_OffsetY()
	x1 = (*target\x*#xTileSize)+(#xTileSize/2)+_OffsetX()
	y1 = (*target\y*#yTileSize)+(#yTileSize/2)+_OffsetY()
	
	lineEquation(x0,y0,x1,y1,10)
	speed = 100/(ListSize(projectile())+1)
	
	FirstElement(projectile())
	If x1 = projectile()\x And y1 = projectile()\y
		LastElement(projectile())
		shootDir = -1
	EndIf
	
	Repeat
		timer = ElapsedMilliseconds()
		Repeat
			_Display()
			_MyFlip()
		Until ElapsedMilliseconds() - timer > speed
		speed+(42/ListSize(projectile()))

		count +1
		If count = ListSize(projectile()) Or Not IsScreenActive()
			Break
		EndIf
		SelectElement(projectile(),ListIndex(projectile())+shootDir)
	ForEver
	ClearList(projectile())
EndProcedure


Procedure actorToAnimation(spriteIndex,alpha,frameMax,animTimer,animLimit,animKillTimer,animKillLimit)
	actor()\spriteIndex = spriteIndex
	actor()\alpha = alpha
	actor()\frameMax = frameMax
	actor()\animTimer = animTimer
	actor()\animLimit = animLimit
	actor()\killTimer = animKillTimer
	actor()\killLimit = animKillLimit
EndProcedure


Procedure moveToAnimation(*origin.ACTOR,x,y,xTarget,yTarget,halfPosition,distance,speed)
	Define dir = getDirection(xTarget-x+1,yTarget-y+1)
	Define move
	Define timer
	Define event
	
	move = 0
	*origin\drawPriority+1
	*origin\xMicro = 0
	*origin\yMicro = 0
	If halfPosition
		*origin\xMicro = ((x*#xTileSize)-(xTarget*#xTileSize))/2
		*origin\yMicro = ((y*#yTileSize)-(yTarget*#yTileSize))/2
	EndIf
	Repeat
		move+2
		*origin\xMicro+xMod(dir)*move
		*origin\yMicro+yMod(dir)*move
		timer = ElapsedMilliseconds()
		Repeat
			_Display()
			_MyFlip()
		Until ElapsedMilliseconds() - timer > speed Or Not IsScreenActive()
	Until move >= distance
	*origin\drawPriority-1
	*origin\xMicro = 0
	*origin\yMicro = 0
EndProcedure


Procedure teleportDeparture(*subject.ACTOR)
	Define event
	Define saveAlpha = *subject\alpha
	Define timer = ElapsedMilliseconds()
	
	If Not withinView(*subject\x,*subject\y)
		ProcedureReturn #False
	EndIf	

	hideMouse = #True
	*subject\alpha = 255
	Repeat
		If ElapsedMilliseconds()-timer > 5
			*subject\rotation + 20
			*subject\alpha -5
			timer = ElapsedMilliseconds()
		EndIf
		_Display()
		_MyFlip()
	Until *subject\alpha <= 0 Or Not IsScreenActive()
	hideMouse = #False
	
	*subject\alpha = saveAlpha
	*subject\rotation = 0
EndProcedure


Procedure teleportArrival(*subject.ACTOR)
	Define event
	Define saveAlpha = *subject\alpha
	Define timer = ElapsedMilliseconds()
	
	If Not withinView(*subject\x,*subject\y)
		ProcedureReturn #False
	EndIf
	
	*subject\alpha = 0
	hideMouse = #True
	Repeat
		If ElapsedMilliseconds()-timer > 5
			*subject\rotation -20
			*subject\alpha +5
			timer = ElapsedMilliseconds()
		EndIf
		_Display()
		_MyFlip()
	Until *subject\alpha >= 255 Or Not IsScreenActive()
	hideMouse = #False
	
	*subject\alpha = saveAlpha
	*subject\rotation = 0
EndProcedure




Procedure screenShake(*subject.ACTOR,intensity,duration)
	Define dice
	Define sequenceDuration = duration/intensity
	Define sequenceTimer = ElapsedMilliseconds()
	Define timer = ElapsedMilliseconds()
	Define event
	
	If *subject And Not (withinView(*subject\x,*subject\y))
		ProcedureReturn #False
	EndIf
	
	If (shakeTimer And intensity > shakeIntensity) Or Not shakeTimer
		shakeIntensity = intensity
	EndIf		
	shakeLimit + duration
	shakeTimer = ElapsedMilliseconds()
EndProcedure


Procedure updateOrientation(status,x,subX)
	If x <> subX
		status = 0
		If x > subX	:	status = 1	:	EndIf
	EndIf
	
	ProcedureReturn status
EndProcedure



Procedure restoreSpriteMemory()
	Define eachCount	
	
	FreeSprite(#PB_All)
	
	_EachActor(#isTempAnimationP,0)
		markForKill(@actor())
	_EndEach()
	checkKillMark()
	
	extSpriteCounter = 1
	Dim extSpriteLib(extSpriteCounter)
	Dim externalSPR(extSpriteCounter)
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 1380
; FirstLine = 1369
; Folding = -----
; EnableXP