﻿

Procedure selectAction(xTarget,yTarget)
	Define inputDelay = 1
	Define *currentPointer.ACTOR
	Define *actionPointer.ACTOR
	Define interactLegit
	Define selection
	Define eachCount
	Define count
	
	LastElement(actor())
	Repeat ;actor-Schleife rückwärts durchlaufen, damit high-drawPriority-actors() erster aufgerufen werden (Monster in Türen)
		If actor()\x = xTarget And actor()\y = yTarget And (Not actor() = *player) And actor()\ident[#canInteractP]
			If Not (actor()\interaction = #selfInteract And (actor()\x <> *player\x Or actor()\y <> *player\y)) ;Items in Türen (AdjacentPickup abfangen)
				
				*currentPointer = @actor()
				
				Select actor()\type
						
					Case #monsterActor
						If isAdjacent(*player\x,*player\y,xTarget,yTarget)
							performMeleeAttack(*player,@actor())
						Else
							performRangedAttack(*player,@actor())
						EndIf
						
					Case #doorActor
						;{
						interactLegit = #False
						If actor()\subtype = #regularDoor
							*actionPointer = #Null
							If actor()\class = 0
								interactLegit = #True
							Else
								If actor()\class <= #maxLockedSort
									If actor()\status = 0
										_EachActor(#isChildP,0)
											If actor()\index = *player\index
												If actor()\type = #itemActor And actor()\subtype = #keyItem And actor()\class = *currentPointer\class
													*actionPointer = @actor()
													Break
												EndIf
											EndIf
										_EndEach()
										Restore message_doorInteraction
										setupMessage()
										mLine$(4) + keyColorText$(*currentPointer\class)	
										If Not *actionPointer
											isOption(4) = #False
										EndIf
										createMessage(-1,-1,4)
										selection = displayMessage()
										Select selection
											Case 1
												If *actionPointer
													*actionPointer\stacks -1
													updateStacks(0,0)
													interactLegit = #True
												EndIf
											Case 2, 3
												destroyDoor(*currentPointer,*player\x,*player\y)
												ProcedureReturn inputDelay
										EndSelect
									Else
										Restore message_doorWarning
										setupMessage()
										createMessage(-1,-1,4)
										selection = displayMessage()
										If selection
											interactLegit = #True
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
						If interactLegit ;Tür normal öffnen
							ChangeCurrentElement(actor(),*currentPointer)
							createDoor(#False,*currentPointer\subtype,*currentPointer\class,*currentPointer\sort,*currentPointer\x,*currentPointer\y,Abs(actor()\status-1))
							markForKill(*currentPointer)
							inputDelay = 250
						Else
							ProcedureReturn #False
						EndIf
						;}
						
					Case #obstacleActor
						;{
						Select actor()\subtype
							Case #oStone
								Restore message_genericStone
								setupMessage()
								createMessage(-1,-1,4)
								displayMessage()
								
							Case #oBrazier
								Restore message_lightBrazier
								setupMessage()
								createMessage(-1,-1,4)
								selection = displayMessage()
								If selection
									markForKill(*currentPointer)
									createBrazier(1,*currentPointer\x,*currentPointer\y)
									updateRadiance(1.0,#True)
									updateShine(*currentPointer\x,*currentPointer\y)
								EndIf
						EndSelect
						;}
						
					Case #itemActor
						Select actor()\subtype
							Case #containerItem
								isInvActive(#floorInv) = #True
								buildFloorInventory(*currentPointer\x,*currentPointer\y)
								rebuildInventory(*currentPointer\x,*currentPointer\y)
								processInventory(*currentPointer\x,*currentPointer\y)							
							Default
								If Not pickupItem(*player,@actor())
									ProcedureReturn #False
								EndIf
						EndSelect
				EndSelect
				
				calculateLOS()
				ChangeCurrentElement(actor(),*currentPointer)
				ProcedureReturn inputDelay
				
			EndIf
		EndIf
		If PreviousElement(actor()) = #Null
			ProcedureReturn #False
		EndIf
	ForEver
EndProcedure



Procedure performMeleeAttack(*origin.ACTOR,*target.ACTOR)
	If withinView(*origin\x,*origin\y) Or withinView(*target\x,*target\y)
		hideMouse = 1
		*origin\status = updateOrientation(*origin\status,*target\x,*origin\x)
		moveToAnimation(*origin,*origin\x,*origin\y,*target\x,*target\y,#False,8,10)
		If *origin = *player	:	screenShake(#Null,4,170) : EndIf
		If *target = *player	:	screenShake(#Null,2,85) : EndIf
		moveToAnimation(*origin,*target\x,*target\y,*origin\x,*origin\y,#True,8,20)
	EndIf
	
	damageActor(*target,*origin\meleeDamageLow,*origin\meleeDamageHigh)

	*origin\inCombat = 0
	*target\inCombat = 0
	

	hideMouse = 0	
	
	ProcedureReturn #True
EndProcedure


Procedure performRangedAttack(*origin.ACTOR,*target.ACTOR)
	Define eachCount
	Define intensity
	
	If withinView(*origin\x,*origin\y) Or withinView(*target\x,*target\y)
		hideMouse = 1
		*origin\status = updateOrientation(*origin\status,*target\x,*origin\x)
		projectileAnimation(*origin,*target)
		hideMouse = 0
	EndIf
	
	If *origin = *player
		_EachActor(#isChildP,0)
			If actor()\index = *player\index And actor()\type = #itemActor And actor()\subtype = #equipableItem And actor()\class = #ammoItem
				actor()\stacks -1
				Break
			EndIf
		_EndEach()
		updateStacks(0,0)
	EndIf
	
	damageActor(*target,*origin\rangedDamage,*origin\rangedDamage)
	
	*origin\inCombat = 0
	*target\inCombat = 0	
	
	If *origin = *player	:	screenShake(#Null,4,170) : EndIf
	If *target = *player	:	screenShake(#Null,2,85) : EndIf
	
	ProcedureReturn #True
EndProcedure


Procedure damageActor(*target.ACTOR,damLow,damHigh)
	Define damage = bellCurveRoll(damLow,damHigh)
	
	If *target\hp > 0
		If (*target\hp-damage = 1) And Not *target = *player	:	damage +1	:	EndIf
		*target\hp - damage
		createHitEffect(*target,damage)
		If *target\hp <= 0
			markForKill(*target)
		EndIf
	EndIf
EndProcedure


Procedure walk(*origin.ACTOR,xDir,yDir)
	Define *current.ACTOR = @actor()
	Define triggered
	Define restoreBresenTile
	
	leaveTile(@actor())
	
	If Not *origin = *player
		If withinView(*origin\x,*origin\y) Or withinView(*origin\x+xDir,*origin\y+yDir)
			*origin\visible = #fullVisibility
			moveToAnimation(*origin,*origin\x,*origin\y,*origin\x+xDir,*origin\y+yDir,#False,8,15)		
			*origin\visible = #defaultVisibility
		EndIf
	EndIf
	
	If xDir Or yDir
		enterTile(*origin,*origin\x+xDir,*origin\y+yDir)
		If withinView(*origin\x,*origin\y) Or withinView(*origin\x+xDir,*origin\y+yDir)	:	calculateLOS()	:	EndIf;Line-of-Sight aktualisieren
		ChangeCurrentElement(actor(),*current)
	EndIf
	
	If checkTrigger(*origin)
		ChangeCurrentElement(actor(),*current)
	EndIf

	ProcedureReturn #True
EndProcedure


Procedure leaveTile(*subject.ACTOR)	
	blockShootMap(*subject\x,*subject\y) - *subject\blockShoot
	collisionMap(*subject\x,*subject\y) - *subject\collision
	bresenRef(*subject\x,*subject\y) - *subject\blockLoS
EndProcedure


Procedure enterTile(*subject.ACTOR,x,y)
	Define count
	Define eachCount
	Define parentIndex
	Define xRef, yRef
	
	*subject\status = updateOrientation(*subject\status,x,*subject\x)
	
	xRef = *subject\x
	yRef = *subject\y
	*subject\x = x
	*subject\y = y
	blockShootMap(*subject\x,*subject\y) + *subject\blockShoot
	collisionMap(*subject\x,*subject\y) + *subject\collision
	bresenRef(*subject\x,*subject\y) + *subject\blockLoS
	For count = #recentMovesMax To 1 Step -1
		*subject\xRecent[count] = *subject\xRecent[count-1]
		*subject\yRecent[count] = *subject\yRecent[count-1]
	Next
	*subject\xRecent[0] = *subject\x
	*subject\yRecent[0] = *subject\y
	
	parentIndex = *subject\index
	_EachActor(#isChildP,0)
		If actor()\x And actor()\index = parentIndex ;Abfrage "If actor()\x" damit auf tile(0,0) platzierte Item-Actors übersprungen werden!
			actor()\x = *subject\x + (actor()\x-xRef)
			actor()\y = *subject\y + (actor()\y-yRef)
		EndIf
	_EndEach()
EndProcedure


Procedure checkTrigger(*subject.ACTOR)
	Define hasMoved
	Define count
	Define eachCount
	Define doTeleport
	
	_EachActor(#isTriggerP,0)
		If actor()\x = *subject\x And actor()\y = *subject\y
			If actor()\type = #teleportActor
				doTeleport = #True
			EndIf
		EndIf
	_EndEach()
	
	If doTeleport
		ForEach teleport()
			If teleport()\dFloor[0] = dFloor And teleport()\active
				If *subject\x = teleport()\x[0] And *subject\y = teleport()\y[0]
					updateNegativeView()
					teleportDeparture(*subject)
					
					If teleport()\dFloor[1] = dFloor
						leaveTile(*subject)
						enterTile(*subject,teleport()\x[1],teleport()\y[1])
						calculateLOS() ;Line-of-Sight aktualisieren
						If *subject = *player
							centerCamera()
							ClearList(aStarPath())
						EndIf
						updateNegativeView()	
						teleportArrival(*subject)
						hasMoved = #True
					Else
						*activeTeleport = @teleport()
						*player\x = 0
						*player\y = 0
						If teleport()\dFloor[1] = 0
							For count = 1 To #maxExit
								If teleport()\x[0] = xExit(count) And teleport()\y[0] = yExit(count)
									Select count
										Case 1	:	entryCardinal = 4
										Case 2	:	entryCardinal = 3
										Case 3	:	entryCardinal = 2
										Case 4	:	entryCardinal = 1
									EndSelect
								EndIf
							Next
							jobDescription = #exploreJob
						Else
							jobDescription = #travelJob
						EndIf
					EndIf
					
					If teleport()\charges > 0
						teleport()\charges -1
						If teleport()\charges = 0
							DeleteElement(teleport())
							markForKill(@actor())
						EndIf
					EndIf
					Break
				EndIf
			EndIf
		Next	
		If *subject = *player And hasMoved
			_EachActor(#isMonsterP,0)
				If Not actor() = *subject
					If actor()\xSearch = *subject\xRecent[2] And actor()\ySearch = *subject\yRecent[2] And canSee(actor()\x,actor()\y,*subject\xRecent[1],*subject\yRecent[1],actor()\vision)
						actor()\xSearch = *subject\xRecent[1]
						actor()\ySearch = *subject\yRecent[1]
					EndIf
				EndIf
			_EndEach()
		EndIf
	EndIf			
	
	ProcedureReturn hasMoved
EndProcedure


Procedure newActorIndex(index)
	Define count
	
	Select index
		Case 0
			ProcedureReturn 0
			
		Case -1	;Neuen Index vergeben
			For count = 1 To indexCounter
				If indexLib(count) = #False
					indexLib(count) = #True
					ProcedureReturn count
				EndIf
			Next
			indexCounter +1
			ReDim indexLib(indexCounter)
			indexLib(indexCounter) = #True
			ProcedureReturn indexCounter
			
		Default	;vorhanden Index eintragen
			If indexCounter < index	
				indexCounter = index
				ReDim indexLib(indexCounter)
			EndIf
			indexLib(index) = #True
			ProcedureReturn index
			
	EndSelect
EndProcedure


Procedure switchActorIdentity(*switchThis.ACTOR,id,newStatus)
	Define count
	
	*switchThis\ident[id] = newStatus
	Select newStatus
		Case #False
			For count = 1 To actorCounter(id)
				If *actorPointer(id,count) = *switchThis
					*actorPointer(id,count) = #Null
					Break
				EndIf
			Next
		Case #True
			actorCounter(id) +1
			ReDim *actorPointer(#actorPointerMax,ArraySize(*actorPointer(),2)+1)
			*actorPointer(id,actorCounter(id)) = *switchThis
	EndSelect
EndProcedure
	


Procedure actorFactory(hasImageI,canInteractI,isDoorI,canMoveI,isAnimI,isTempAnimI,isMonsterI,isItemI,isChildI,isEffectI,isTriggerI,isDimI,isGadgetI,
						index,type,subtype,class,sort,quality,status,
						drawPriority,visible,collision,blockShoot,blockLoS,interaction,x,y,hp)
	Define *origin.ACTOR
	Define *localPointer.ACTOR
	Define ap
	Dim count(#actorPointerMax)
	Define highestDim
	
	LastElement(actor())
	If ListSize(actor()) <> #Null And actor()\drawPriority > drawPriority
	;funktioniert, weil <>#Null-Abfrage zuerst abgearbeitet wird (kein "Invalid Memory Access" bei leerer Liste)
		ForEach actor()
			If actor()\drawPriority >= drawPriority
				InsertElement(actor())
				Break
			EndIf
		Next
	Else
		AddElement(actor())
	EndIf
	
	actor()\ident[#hasImageP] = hasImageI
	actor()\ident[#canInteractP] = canInteractI
	actor()\ident[#isDoorP] = isDoorI
	actor()\ident[#canMoveP] = canMoveI
	actor()\ident[#isAnimationP] = isAnimI
	actor()\ident[#isTempAnimationP] = isTempAnimI
	actor()\ident[#isMonsterP] = isMonsterI
	actor()\ident[#isItemP] = isItemI
	actor()\ident[#isChildP] = isChildI
	actor()\ident[#isEffectP] = isEffectI
	actor()\ident[#isTriggerP] = isTriggerI
	actor()\ident[#isDimensionP] = isDimI
	actor()\ident[#isGadgetP] = isGadgetI
	
	actor()\alpha = 255
	actor()\type = type
	actor()\subtype = subtype
	actor()\class = class
	actor()\sort = sort
	actor()\quality = quality
	actor()\status = status
	actor()\drawPriority = drawPriority
	actor()\visible = visible
	actor()\collision = collision
	actor()\blockShoot = blockShoot
	actor()\blockLoS = blockLoS
	actor()\interaction = interaction
	actor()\x = x
	actor()\y = y
	actor()\hp = hp
	

	blockShootMap(actor()\x,actor()\y) + actor()\blockShoot
	collisionMap(actor()\x,actor()\y) + actor()\collision
	bresenRef(actor()\x,actor()\y) + actor()\blockLoS
	
	actor()\index = newActorIndex(index)

	*localPointer = @actor()
	*origin = *localPointer
	
	If gameRunning 
		If actor()\collision > #removableCollision
			iniSearchDijkstra = #True
			iniGatherDijkstra = #True
		EndIf
		If actor()\type = #monsterActor And _MonCon(#monGather)
			iniGatherDijkstra = #True
		EndIf
	EndIf
	

	For ap = 0 To #actorPointerMax
		If actor()\ident[ap]
			actorCounter(ap) +1
		EndIf
		If actorCounter(ap) > highestDim
			highestDim = actorCounter(ap)
		EndIf
	Next
	Dim *actorPointer(#actorPointerMax,highestDim)
	ForEach actor()
		For ap = 0 To #actorPointerMax
			If actor()\ident[ap]
				count(ap) +1
				*actorPointer(ap,count(ap)) = @actor()
			EndIf
		Next
	Next
	For ap = 0 To #actorPointerMax
		actorCounter(ap) = count(ap)
	Next
	ChangeCurrentElement(actor(),*localPointer)
EndProcedure


Procedure checkKillMark()
	Define killed
	Define noChange

	Repeat
		killed = #False
		noChange = #True
		ForEach actor()
			If actor()\hp <> 0
				Continue
			EndIf
			noChange = #False
			killed = #True
			killActor(@actor())
		Next
	Until noChange
EndProcedure


Procedure markForKill(*deletePointer.ACTOR)
	Define eachCount
	Define *origin.ACTOR = *deletePointer
	
	*deletePointer\visible = #nullVisibility
	blockShootMap(*deletePointer\x,*deletePointer\y) - *deletePointer\blockShoot
	collisionMap(*deletePointer\x,*deletePointer\y) - *deletePointer\collision
	bresenRef(*deletePointer\x,*deletePointer\y) - *deletePointer\blockLoS	
	
	If gameRunning 
		If *deletePointer\collision > #removableCollision
			iniSearchDijkstra = #True
			iniGatherDijkstra = #True
		EndIf
		If *deletePointer\type = #monsterActor And _MonCon(#monGather)
			iniGatherDijkstra = #True
		EndIf
		If *deletePointer\invLocation
			_EachActor(#isMonsterP,#Null)
				If actor()\index = *deletePointer\index
					actor()\inventory[*deletePointer\invLocation] = 0
					Break
				EndIf
			_EndEach()
		EndIf
		If *deletePointer\blockLoS
			calculateLOS()
			updateNegativeView()
		EndIf
	EndIf
	
	*deletePointer\hp = 0
	ChangeCurrentElement(actor(),*deletePointer)
EndProcedure


Procedure killActor(*deletePointer.ACTOR)
	Define count
	Define ap
	Define eachCount
	
	ChangeCurrentElement(actor(),*deletePointer)	
	
	For ap = 0 To #actorPointerMax
		If actor()\ident[ap]
			For count = 0 To actorCounter(ap)
				If *actorPointer(ap,count) = @actor()
					*actorPointer(ap,count) = #Null  ;Alle assoziierten Actor-Pointer müssen gelöscht werden!!! (kein vorzeitiger Break)
				EndIf
			Next
		EndIf
	Next
	
	If *deletePointer\ident[#isChildP] = #False
		indexLib(*deletePointer\index) = #False
	EndIf
	
	;Kill Associate Actors
	If Not *deletePointer\ident[#isChildP]
		_EachActor(#isChildP,0)
			If actor()\index = *deletePointer\index
				markForKill(@actor())
			EndIf
		_EndEach()
	EndIf
	
	If *deletePointer = *debug
		*debug = #Null
	EndIf

	ChangeCurrentElement(actor(),*deletePointer)
	
	
	DeleteElement(actor())
EndProcedure


Procedure overrideCollision(*location.ACTOR,newCollision)
	*location\collision = newCollision
	collisionMap(*location\x,*location\y) = newCollision
	If newCollision > #removableCollision
		iniGatherDijkstra = #True
		iniSearchDijkstra = #True
	EndIf
EndProcedure


Procedure destroyDoor(*thisDoor.ACTOR,thisX,thisY)
	Define dir
	
	shakeDoorAnimation(*thisDoor,150)
	markForKill(*thisDoor)
	*thisDoor\visible = #nullVisibility
	floorMap(*thisDoor\x,*thisDoor\y) = floorMap(thisX,thisY)
	ForEach freeField()
		If freeField()\x = *thisDoor\x And freeField()\y = *thisDoor\y
			freeField()\value = floorMap(*thisDoor\x,*thisDoor\y)
			Break
		EndIf
	Next
	For dir = 0 To 8
		editBaseMap(*thisDoor\x+xMod(dir),*thisDoor\y+yMod(dir))
	Next
	screenShake(*thisDoor,4,200)
	
	ChangeCurrentElement(actor(),*thisDoor)
EndProcedure


Procedure processTimer()
	Define eachCount
	Define synchPortal
	
	_EachActor(#isAnimationP,#Null)
		If actor()\animLimit > 0 And ElapsedMilliseconds()-actor()\animTimer > actor()\animLimit
			actor()\frame +1
			If actor()\frame > actor()\frameMax
				actor()\frame = 0
			EndIf
			actor()\animTimer = ElapsedMilliseconds()
		EndIf
		;{ SYNCH CHILD ANIMATIONS
		If actor()\type = #teleportActor And actor()\subtype = #tPortal
			If synchPortal		:	actor()\frame = synchPortal-1 :	EndIf
			If Not synchPortal	:	synchPortal = actor()\frame+1 :	EndIf
		EndIf
		;}
		
		If Not actor()\killLimit 
			Continue
		EndIf
		If ElapsedMilliseconds()-actor()\killTimer > actor()\killLimit
			If actor()\spriteIndex > 0
				If IsSprite(externalSPR(actor()\spriteIndex))
					FreeSprite(externalSPR(actor()\spriteIndex))
				EndIf
				extSpriteLib(actor()\spriteIndex) = #False
			EndIf
			markForKill(@actor())
		EndIf
	_EndEach()
	
	If shakeTimer
		If ElapsedMilliseconds()-shakeTimer > shakeLimit
			shakeTimer = 0
			shakeLimit = 0
			shakeIntensity = 0
			xShake = 0
			yShake = 0
		Else
			xShake = xMod(Random(4,1))*shakeIntensity
			yShake = xMod(Random(4,1))*shakeIntensity
		EndIf
	EndIf
EndProcedure


Procedure resolveEffects()
	Define *current.ACTOR
	Define parentLoop
	Define eachCount
	
	_EachActor(#isEffectP,0)
		*current = @actor()		
		parentLoop = eachCount		
		
		actor()\killTimer +1
		If actor()\killTimer >= actor()\killLimit
			;wearOff-Effects
			Select actor()\subtype
				Case #ePathBlocker
					_EachActor(#isDoorP,0)
						If actor()\x = *current\x And actor()\y = *current\y
							overrideCollision(@actor(),#removableCollision)
							Break
						EndIf
					_EndEach()
			EndSelect
			
			ChangeCurrentElement(actor(),*current)
			markForKill(@actor())
		EndIf
		
		eachCount = parentLoop
	_EndEach()
EndProcedure


Procedure withinView(x,y)
	Define dir
	
	_Dist(x,y,*player\x,*player\y)
	If bresenMap(x,y) And distance <= radiance
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure withinScreen(x,y)
	If x >= (xViewCenter-xMaxView) And x <= (xViewCenter+xMaxView) And y >= (yViewCenter-yMaxView) And y <= (yViewCenter+yMaxView)
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure calculateLOS()
	;	DisableDebugger
	Define eachCount
	Define dir
	Define x, y
	Dim bresenSave(1,1)
	Define bSave
	Define *actorTemp.ACTOR = @actor()
	
	Dim bresenMap(#xMax,#yMax)
	
	Define x0 = limit(*player\x-lineOfSight,0,xMax)
	Define x1 = limit(*player\x+lineOfSight,0,xMax)
	Define y0 = limit(*player\y-lineOfSight,0,yMax)
	Define y1 = limit(*player\y+lineOfSight,0,yMax)
	
	If *player\x = 0 Or *player\y = 0	:	ProcedureReturn #False	:	EndIf
	
	Dim viewMatrix(xMax,yMax)
	For dir = 0 To 4
		y = y0+dir
		For x = x0 To x1
			getBresenham(*player\x,*player\y,x,y,#True)
		Next
		x = x1-dir
		For y = y0 To y1
			getBresenham(*player\x,*player\y,x,y,#True)
		Next
		y = y1-dir
		For x = x1 To x0 Step -1
			getBresenham(*player\x,*player\y,x,y,#True)
		Next
		x = x0+dir
		For y = y1 To y0 Step -1
			getBresenham(*player\x,*player\y,x,y,#True)
		Next
	Next
	viewMatrix(*player\x,*player\y) = #True
	bresenMap(*player\x,*player\y) = #True
	exploreMap(*player\x,*player\y) = #True
	
	Dim canInteractMap(xMax,yMax)
	CopyArray(bresenRef(),bresenSave())
	CopyArray(blockShootMap(),bresenRef())	
	bresenRef(*player\x,*player\y) = 0 ;damit Bresenham in beide Richtungen funktioniert
	
	_EachActor(#canInteractP,0)
		If actor()\interaction = #rangedInteract And *player\x = actor()\x And *player\y = actor()\y
			canInteractMap(actor()\x,actor()\y) = -1
		EndIf
		If (Not withinScreen(actor()\x,actor()\y)) Or (Not bresenMap(actor()\x,actor()\y)) Or canInteractMap(actor()\x,actor()\y) = -1 
			Continue
		EndIf
		Select actor()\interaction
			Case #rangedInteract
				If Not isAdjacent(*player\x,*player\y,actor()\x,actor()\y) And Not *player\ableRanged
					canInteractMap(actor()\x,actor()\y) = #False
				Else
					_Dist(*player\x,*player\y,actor()\x,actor()\y)
					If distance <= *player\maxActorRange
						bSave = bresenRef(actor()\x,actor()\y)
						bresenRef(actor()\x,actor()\y) = 0
						If getBresenham(*player\x,*player\y,actor()\x,actor()\y,0) Or getBresenham(actor()\x,actor()\y,*player\x,*player\y,0) ;Bresenham ist asymmetrisch!
							canInteractMap(actor()\x,actor()\y) = #True
						EndIf
						bresenRef(actor()\x,actor()\y) = bSave
					EndIf
				EndIf
			Case #adjacentInteract
				If isAdjacent(*player\x,*player\y,actor()\x,actor()\y)
					canInteractMap(actor()\x,actor()\y) = #True
				EndIf
			Case #selfInteract
				If *player\x = actor()\x And *player\y = actor()\y
					canInteractMap(actor()\x,actor()\y) = #True
				EndIf
			Case #fullInteract
				If isAdjacent(*player\x,*player\y,actor()\x,actor()\y) Or (*player\x = actor()\x And *player\y = actor()\y)
					canInteractMap(actor()\x,actor()\y) = #True
				EndIf				
		EndSelect
	_EndEach()
	If canInteractMap(*player\x,*player\y) = -1
		canInteractMap(*player\x,*player\y) = #False	
	EndIf


	ChangeCurrentElement(actor(),*actorTemp)
	CopyArray(bresenSave(),bresenRef())
	
	bresenMap(*player\x,*player\y) = 1
	ProcedureReturn #True
EndProcedure


Procedure checkCanRanged()
	Define hasRangedWeapon
	Define hasAmmo
	Define eachCount
	
	_EachActor(#isChildP,0)
		If actor()\type = #itemActor And actor()\subtype = #equipableItem And actor()\index = *player\index
			If actor()\class = #rangedItem
				hasRangedWeapon = 1
			EndIf
			If actor()\class = #ammoItem
				hasAmmo = 1
			EndIf
		EndIf
	_EndEach()
	
	If hasRangedWeapon+hasAmmo = 2
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure updateRadiance(value.f,updateLoS)
	radiance = limitFloat(radiance+value,radianceMin,radianceMax)
	
	If updateLoS
		calculateLOS()	
		updateViewport()	
		updateNegativeView()
	EndIf
EndProcedure


Procedure createEffect(subtype,parentIndex,x,y)
	Define *currentSubject.ACTOR = @actor()
	actorFactory(#False,#False,#False,#False,#False,#False,#False,#False,#True,#True,#False,#False,#False,
					parentIndex,#effectActor,subtype,0,0,0,0,0,#False,#False,#False,#False,#False,x,y,-1)	
	
	actor()\killTimer = 0
	Select subtype
		Case #ePathBlocker
			actor()\killLimit = Random(50,10)
	EndSelect
		
	ChangeCurrentElement(actor(),*currentSubject)
EndProcedure


Procedure cancelSubMenu()
	If Not IsScreenActive() Or MouseX() = 0 Or MouseX() = #xRes-1 Or MouseY() = 0 Or MouseY() = #yRes-1
		ProcedureReturn #True
	EndIf
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 852
; FirstLine = 818
; Folding = -----
; EnableXP
; Executable = Test.exe